Attribute VB_Name = "Declarations"
' ***************************************************************************
' *                                                                         *
' * Autor           :   Mike Eitel                                          *
' * Datum           :   10. October 1999                                    *
' * Version         :   1.0                                                 *
' * Module Name     :   SNAP_Declarations                                   *
' * Zweck           :   This File contains all constants,globale Variabeles *
' *                     and Type definitions.                               *
' *                                                                         *
' ***************************************************************************

'Generel Variables
Public tmp As Integer
Public Tx As Type_TXData
Public Rx As Type_RXData
Public SPY As Type_RXData
Public Statistic As Type_Statistics
Public Version As Type_Version
Public Data As Type_DataBytes
Public Packet As Type_Packet
Public Nr_of_Preamble As Integer
Public TxtDAD As Integer
Public TxtSAD As Integer

Public DATAS(16)    As Byte                         ' Variables in sub node
Public Command As Byte                              ' Command that is use
Public By1 As Byte                                  ' Byte Db1
Public By2 As Byte                                  ' Byte Db2
Public By3 As Byte                                  ' Byte Db3
Public By4 As Byte                                  ' Byte Db4
Public My_Address As Byte
Public Dest_Address As Byte

'Declaration
Public Declare Function DLLVersion Lib "snap.dll" () As Type_Version
Public Declare Sub SetMyAddress Lib "snap.dll" (ByVal Address As Integer)
Public Declare Function Myaddress Lib "snap.dll" Alias "MyAddress" () As Integer
Public Declare Function SendData Lib "snap.dll" (TXData As Type_TXData) As Boolean
Public Declare Function GetTXPacket Lib "snap.dll" (Packet As Type_Packet) As Boolean
Public Declare Function RXByteIn Lib "snap.dll" (ByVal InByte As Byte) As Boolean
Public Declare Function GetSPYData Lib "snap.dll" (RXData As Type_RXData) As Boolean
Public Declare Function GetRXData Lib "snap.dll" (RXData As Type_RXData) As Boolean
Public Declare Sub GetStatistics Lib "snap.dll" (Statistics As Type_Statistics)

'Constants
Public Const SYNCSIZE = 1
Public Const MAXADDRESSSIZE = 3
Public Const MAXPFBFLAGS = 3
Public Const MAXEDMSIZE = 4
Public Const MAXDATASIZE = 512
Public Const MAXPACKSIZE = 1042
Public Const PREAMBLE = 77

'Definitions of data records used by SNAP.DLL

'Declaration of a Version structure
Public Type Type_Version
    Major As Byte
    Minor As Byte
End Type

'Declaration of a DataBytes structure
Public Type Type_DataBytes
    Byt(1 To MAXDATASIZE) As Byte
End Type

'Declaration of a PacketBytes structure
Public Type Type_PacketBytes
    Byt(1 To MAXPACKSIZE) As Byte
End Type

'Declaration of a Packet structure
'This is the encoded packet from the S.N.A.P encoder (GetTXPacket)
Public Type Type_Packet
    NumOfBytes As Integer
    PacketBytes As Type_PacketBytes
    Time As Date
End Type

'Declaration of a TXData structure
'This is the data that you want to send to a specified node (SendData)
Public Type Type_TXData
    DestAdd As Long             '-1=No Destination address was used. 0=Broadcast
    Data As Type_DataBytes      'Data
    NumOfDataBytes As Integer   'How many bytes in the Data array that is used
    ErrorMode As Byte           'The Errordetection mode do you want to use.
    Ack As Byte                 'Sets and gets ACK bits 0-3
    Cmd As Byte                 'Sets command mode bit
End Type

'Declaration of a RXData structure
'This is the received data from the RX packet decoder (GetRXData)
Public Type Type_RXData
    DestAdd As Long             '-1=No Destination address was used. 0=Broadcast
    SourceAdd As Long           '-1=No Source address was used. 0=Broadcast
    Data As Type_DataBytes      'Data
    NumOfDataBytes As Integer   'How many bytes in the Data array that is used
    EDMBits As Byte             'Only bits 0-3 is used, nice to have.
    ACKBits As Byte             'Only bits 0-3 is used, indicates if it was an ACK response
    CMDBit As Byte              'Only bit 0 is used, indicates if command mode is enabled/disabled
    RXTime As Date              'Time stamp of Inpacket
End Type

'Declaration of Statistics structure
'This is passed from the GetStatistics call
Public Type Type_Statistics
    RejectedPackets As Long     'Counter of Packets wich didn't pass error (CRC) check (May or may not be addressed to this node)
    TransmittedPackets As Long  'Counter of transmitted packet that was sent from this node
    ReceivedPackets As Long     'Counter of packet that was  received and was either addressed to this node or was a broadcast packet
    TotalPackets As Long        'Counter of total packets that was seen on the network
    RejectedBytes As Long       'Counter of Bytes that was missaligned (also includes preamble bytes), ie that was sent before a SYNC byte
    TransmittedBytes As Long    'Counter of Transmitted bytes from this node
    ReceivedBytes As Long       'Counter of Bytes that was received in addressed packets (was either addressed to this node or was a broadcast packet)
    TotalBytes As Long          'Counter of Bytes that was seen on the network
    StartTime As Date           'Gives you the date and time when the DLL was initialized
End Type


